class PushsController < ApplicationController
  include ActionController::HttpAuthentication::Token
  skip_before_action :verify_authenticity_token

  def token
    param! :app_name, String, required: true
    param! :app_id, String, required: true
    param! :app_secret, String, required: true

    app_setting = AppSettings.send(params[:app_name].to_sym) rescue {}
    if app_setting['app_id'] == params[:app_id] && app_setting['app_secret'] == params[:app_secret]
      render json: { code: 0, message: 'success', token: Token.generate_token(params[:app_name]), ttl: Token.ttl(params[:app_name])}
    else
      render json: { code: -1, message: '应用不存在或者app_id/app_secret不匹配'}
    end
  end

  def push
    param! :app_name, String, required: true
    param! :user_device_ids, Array, required: true
    param! :message, String, required: true
    
    token = token_and_options(request).first
    if token == Token.token(params[:app_name])
      ::PushWorker.perform_async(params[:user_device_ids], JSON.parse(params[:message]))
      render json: { code: 0, message: 'success'}
    else
      render json: { code: -1, message: 'token 错误/过期'}
    end
  end
end
