module Push
  class << self
    # transmission_content 是真正的推送信息
    # {
      #   transmission_content: opts,
      #   transmission_type: transmission_type
      # }
    def push(user_device_ids, message)
      Log.info("push: user_device_ids: #{user_device_ids}, message: #{message}")
      message = message.with_indifferent_access

      # igetui
      Igetui.push(user_device_ids, message)

      # xiaomi
      # https://dev.mi.com/console/doc/detail?pId=1163 文档中心
      Xiaomi.push(user_device_ids, message['transmission_content'])

      # huawei
      # https://developer.huawei.com/consumer/cn/service/hms/catalog/huaweipush_agent.html?page=hmssdk_huaweipush_api_reference_agent_s1 接入文档
      Huawei.push(user_device_ids, message['transmission_content'])

      # etc
    rescue StandardError => err
      Log.error(err)
    end
  end
end
